%%

%public
%class Scanner
%function token
%type Token
%line

%%

[ \n\r\t]    { }
[{]~[}]    { }

[0-9]+  { return new Token(Token.NUM, yytext(), yyline); }
[0-9]+[.][0-9]+ { return new Token(Token.NUM, yytext(), yyline); }

write    { return new Token(Token.WRITE, yytext(), yyline); }
read    { return new Token(Token.READ, yytext(), yyline); }
if    { return new Token(Token.IF, yytext(), yyline); }
then    { return new Token(Token.THEN, yytext(), yyline); }
else    { return new Token(Token.ELSE, yytext(), yyline); }
end    { return new Token(Token.END, yytext(), yyline); }
repeat    { return new Token(Token.REPEAT, yytext(), yyline); }
until    { return new Token(Token.UNTIL, yytext(), yyline); }
var    { return new Token(Token.VAR, yytext(), yyline); }
procedure { return new Token(Token.PROC, yytext(), yyline); }
int   { return new Token(Token.INT, yytext(), yyline); }
real  { return new Token(Token.REAL, yytext(), yyline); }
bool  { return new Token(Token.BOOL, yytext(), yyline); }

[a-zA-Z][a-zA-Z0-9_]* { return new Token(Token.ID, yytext(), yyline); }

[:][=] { return new Token(Token.ATRIB, yytext(), yyline); }

<<EOF>>    { return new Token(0, "<<EOF>>", yyline); }

.          { return new Token(yytext().charAt(0), yytext(), yyline); }

